Name:           HandBrake
Version:        0.9.9
Release:        1%{?dist}
Summary:        An open-source multiplatform video transcoder

License:        GPLv2+
URL:            http://handbrake.fr/
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2
Patch1:         %{name}-%{version}-use-unpatched-libmkv.patch
Patch2:         %{name}-%{version}-use-unpatched-a52.patch
Patch3:         %{name}-%{version}-remove-dvdnav-dup.patch

ExclusiveArch:  %{ix86} x86_64

# The project fetches libraries to bundle in the executable at compile time; to
# have them available before building, proceed as follows. All files will be
# available in the "download" folder.
#
# ./configure
# cd build
# make contrib.fetch

Source11:       http://download.handbrake.fr/handbrake/contrib/faac-1.28.tar.gz
Source12:       http://download.handbrake.fr/handbrake/contrib/mp4v2-trunk-r355.tar.bz2
Source13:       http://download.handbrake.fr/handbrake/contrib/libav-v9.6.tar.bz2

BuildRequires:  a52dec-devel >= 0.7.4
BuildRequires:  bzip2-devel
BuildRequires:  dbus-glib-devel
BuildRequires:  desktop-file-utils
BuildRequires:  fontconfig-devel
BuildRequires:  freetype-devel
BuildRequires:  fribidi-devel
BuildRequires:  gstreamer-devel
BuildRequires:  gstreamer-plugins-base-devel
BuildRequires:  intltool
BuildRequires:  lame-devel >= 3.98
BuildRequires:  libass-devel
BuildRequires:  libbluray-devel
BuildRequires:  libdvdnav-devel
BuildRequires:  libdvdread-devel
BuildRequires:  libgudev1-devel
BuildRequires:  libmkv-devel >= 0.6.5
BuildRequires:  libmpeg2-devel >= 0.5.1
BuildRequires:  libnotify-devel
BuildRequires:  libogg-devel
BuildRequires:  libsamplerate-devel
BuildRequires:  libtheora-devel
BuildRequires:  libtool
BuildRequires:  libvorbis-devel
BuildRequires:  libxml2-devel
BuildRequires:  m4
BuildRequires:  make
BuildRequires:  patch
BuildRequires:  python
BuildRequires:  subversion
BuildRequires:  tar
BuildRequires:  webkitgtk-devel
BuildRequires:  wget
BuildRequires:  x264-devel
BuildRequires:  yasm
BuildRequires:  zlib-devel

Requires:       hicolor-icon-theme

%description
%{name} is a general-purpose, free, open-source, cross-platform, multithreaded
video transcoder software application. It can process most common multimedia
files and any DVD or Bluray sources that do not contain any kind of copy
protection.

%package gui
Summary:        An open-source multiplatform video transcoder (GUI)
Obsoletes:      HandBrake < %{version}-%{release}
Provides:       HandBrake = %{version}-%{release}
Requires:       hicolor-icon-theme
Requires:       libdvdcss%{_isa}

%description gui
%{name} is a general-purpose, free, open-source, cross-platform, multithreaded
video transcoder software application. It can process most common multimedia
files and any DVD or Bluray sources that do not contain any kind of copy
protection.

This package contains the main program with a graphical interface.

%package cli
Summary:        An open-source multiplatform video transcoder (CLI)
Requires:       libdvdcss%{_isa}

%description cli
%{name} is a general-purpose, free, open-source, cross-platform, multithreaded
video transcoder software application. It can process most common multimedia
files and any DVD or Bluray sources that do not contain any kind of copy
protection.

This package contains the command line version of the program.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1

mkdir -p download
cp %{SOURCE11} %{SOURCE12} %{SOURCE13} download

%build
# This makes build stop if any download is attempted
export http_proxy=http://127.0.0.1

# Use system libraries in place of bundled ones
for module in lame libmkv mpeg2dec x264 a52dec libdvdnav libdvdread libbluray libvpx; do
    sed -i -e "/MODULES += contrib\/$module/d" make/include/main.defs
done

# By default the project is built with optimizations for speed and no debug.
# Override configure settings by passing RPM_OPT_FLAGS and disabling preset
# debug options.
echo "GCC.args.O.speed = ${RPM_OPT_FLAGS}" > custom.defs
echo "GCC.args.g.none = " >> custom.defs

# Not an autotools configure script.
./configure \
    --prefix=%{_prefix} \
    --verbose \
    --disable-gtk-update-checks \
    --build build

# SMP flags break build
make -C build

%install
make -C build DESTDIR=%{buildroot} install

desktop-file-validate %{buildroot}/%{_datadir}/applications/ghb.desktop

%post gui
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :

%postun gui
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
/usr/bin/update-desktop-database &> /dev/null || :

%posttrans gui
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files gui
%doc AUTHORS COPYING CREDITS NEWS THANKS TRANSLATIONS
%{_bindir}/ghb
%{_datadir}/applications/ghb.desktop
%{_datadir}/icons/hicolor/*/apps/hb-icon.png

%files cli
%doc AUTHORS COPYING CREDITS NEWS THANKS TRANSLATIONS
%{_bindir}/HandBrakeCLI

%changelog
* Fri Jun 19 2015 Simone Caronni <negativo17@gmail.com> - 0.9.9-1
- Update to 0.9.9.
- Remove system libraries patch, remove modules from the new main.defs file.

* Fri Mar 28 2014 Simone Caronni <negativo17@gmail.com> - 0.9.8-1
- First build for el6.
- Use system libraries for everything except faac, libbluray, libdca, mp4v2 and
  ffmpeg.
